=== debian/changelog ===
slicer (3.4.0~svn10438-7) unstable; urgency=low

  * Fixed FTBFS with ITK 3.18 (Closes: #583001)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 08 Jun 2010 16:36:18 -0400

slicer (3.4.0~svn10438-6) unstable; urgency=low

  * Upstream patches until svn revision 12406 included
  * gdcm.dic added
  * private .so files moved from libslicer3-dev to slicer

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Sun, 21 Mar 2010 12:38:29 -0400

slicer (3.4.0~svn10438-5) unstable; urgency=low

  * added patch for compiling with vtk 5.4 (Closes: #567692)
  * BIFF_STRLEN definition for vtkTeem added
  * Bump standard version to 3.8.4

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 01 Feb 2010 21:46:02 -0500

slicer (3.4.0~svn10438-4) unstable; urgency=low

  * Add build deps: libmysqlclient-dev, libgl2ps-dev, libavcodec-dev, libpq-dev,
                    libswscale-dev, default-jdk, mpi-default-dev, libavformat-dev
                    (Closes: #562351)
  * Fixed strrchr/<cstring> issue

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Wed, 06 Jan 2010 22:06:38 -0500

slicer (3.4.0~svn10438-3) unstable; urgency=low

  * Keep RegisterImages deactivated
  * skipping itkConceptChecking (Closes: #549790)

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 28 Sep 2009 20:57:12 -0400

slicer (3.4.0~svn10438-2) unstable; urgency=low

  * debian/control: Conflicts entry added (Closes: #547505)
    libslicer3-dev conflicts with libmrml1-dev now
  * Using CMake's include_directories instead of include
    to fix a build error on kFreeBSD
  * quilt patch file added to cherry pick upstream's SVN changes

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Mon, 21 Sep 2009 14:16:02 -0400

slicer (3.4.0~svn10438-1) unstable; urgency=low

  * switch to Tcl/Tk 8.5
  * change patch system to quilt
  * move some runtime files to libslicer3 (Closes: #541890)
  * Bump standard version to 3.8.3

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Sun, 13 Sep 2009 15:23:19 -0400

slicer (3.4.0~svn10317-1) experimental; urgency=low

  * Launcher added: /usr/bin/Slicer-launcher
  * Installing Slicer3Version.txt

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Tue, 20 Aug 2009 15:32:25 -0400

slicer (3.4.0~svn10133-1) experimental; urgency=low

  * Add libgdcm2-dev dependency
  * Bump standard version to 3.8.2

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Thu, 06 Aug 2009 09:40:41 -0400

slicer (3.4.0~svn9703-1) experimental; urgency=low

  * Initial release (Closes: #500841)

 -- Dominique Belhachemi <domibel@cs.tu-berlin.de>  Fri, 12 Jun 2009 10:03:15 -0400
