=== debian/control ===
Source: slicer
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Dominique Belhachemi <domibel@debian.org>
Build-Depends: debhelper (>= 7), quilt, cmake, tcl8.5-dev, tk8.5-dev, libexpat1-dev,
 libinsighttoolkit3-dev (>= 3.16), libkwwidgets1-dev,
 libvtk5-dev (>= 5.2.1-11), libteem1-dev, libopenigtlink1-dev,
 libbz2-dev, libxft-dev, libtclap-dev, libgdcm2-dev, libfftw3-dev,
 libcurl4-openssl-dev, libopenjpeg-dev, uuid-dev
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 3.8.4
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/slicer/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/slicer/trunk/
Section: graphics
Homepage: http://www.slicer.org/


Package: slicer
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 slicer-data, itcl3, iwidgets4, tcllib, tcl8.5-kwwidgets
Description: software package for visualization and image analysis - main application
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks. 
 .
 3D Slicer main application.


Package: libslicer3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Description: software package for visualization and image analysis - runtime
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer libraries.


Package: libslicer3-dev
Section: libdevel
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends} 
Conflicts: libmrml1-dev
Description: software package for visualization and image analysis - development
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer development files.


Package: slicer-data
Section: doc
Architecture: all
Depends: ${misc:Depends}, tk8.5 | wish
Description: software package for visualization and image analysis - share
 Slicer is an application for computer scientists and clinical researchers. The 
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer data files.
